import java.io.InputStream;


enum DeviceType {GENERAL, DEVICE_1};


public class Device {

	private final static String CLIENT_MIDDLEWARE_IP = "127.0.0.1";
	private final static Integer CLIENT_MIDDLEWARE_PORT = 7377;
	
	DeviceType m_deviceType;
	DeviceGeneral m_deviceGeneral;
	
	public Device(DeviceType deviceType) throws DeviceException {
		m_deviceType = deviceType;
		
		switch(m_deviceType) {
		case GENERAL: m_deviceGeneral = new DeviceGeneral(CLIENT_MIDDLEWARE_IP, CLIENT_MIDDLEWARE_PORT);
					break;
					
		case DEVICE_1: ;
					break;

		default: throw new DeviceException("invalid device device type");
		}
	}
	
	public void playPcmPlayer(InputStream stream) {
		switch(m_deviceType) {
		case GENERAL: m_deviceGeneral.playPcmPlayer(stream);
					break;
		
		case DEVICE_1: ;
					break;
		}
	}
	
	public void stopPcmPlayer() {
		switch(m_deviceType) {
		case GENERAL: m_deviceGeneral.stopPcmPlayer();
					break;
		
		case DEVICE_1: ;
					break;
		}
	}
}
