import java.io.IOException;
import java.io.InputStream;
import java.net.Socket;



public class DeviceGeneral {
	
	private final static Integer CMD_PCMPLAYER = 1;
	
	private final static Integer SUBCMD_PCMPLAYER_START = 1;
	private final static Integer SUBCMD_PCMPLAYER_STOP = 0;
	
	private final static ProxyToServer m_proxyToRobotClient = new ProxyToServer();
	
	private String m_ip;
	private int m_port;
	
	
	public DeviceGeneral(String ip, int port) {
		m_ip = ip;
		m_port = port;
	}
	
	void setIP(String ip) {
		m_ip = ip;
	}
	
	void setPort(int port) {
		m_port = port;
	}
	
	private Socket initSocket() {
		try {
			return m_proxyToRobotClient.initSocket(m_ip, m_port);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return null;
	}
	
	private void clearSocket(Socket sock) {
		try {
			m_proxyToRobotClient.clearSocket(sock);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void playPcmPlayer(InputStream stream) {
		byte[] ret=null;
		
		try {
			/*
			byte[] buf = new byte[1024*10];
			FileInputStream fileInputStream = (FileInputStream) stream;
			FileOutputStream fileOutputStream = new FileOutputStream("c:\\b.wav", true);
			
			BufferedInputStream bin = new BufferedInputStream(fileInputStream);
			BufferedOutputStream bout = new BufferedOutputStream(fileOutputStream);
			
			int bytesRead = 0;
			while ((bytesRead = bin.read(buf, 0, 1024)) != -1) {
			    bout.write(buf, 0, bytesRead);
			}
			bout.close();
			bin.close();
			fileInputStream.close();
			fileOutputStream.close();
			*/
			
			Socket sock = initSocket();
			
			if(sock != null) {
				m_proxyToRobotClient.sendRequestPcmPlayer(sock, CMD_PCMPLAYER, SUBCMD_PCMPLAYER_START, stream);
				ret = m_proxyToRobotClient.recvResponse(sock, CMD_PCMPLAYER, SUBCMD_PCMPLAYER_START);
			
				clearSocket(sock);
			}
			
			if(ret == null) {
				System.out.println("[ERROR] Fail to play PcmPlayer.");
			}
		} catch (IOException e) {
			System.out.printf("[EXCEPTION] play PcmPlayer - %s\n", e.getMessage());
		}
	}
	
	public void stopPcmPlayer() {
		byte[] ret=null;
		
		try {
			Socket sock = initSocket();
			
			if(sock != null) {
				m_proxyToRobotClient.sendRequestPcmPlayer(sock, CMD_PCMPLAYER, SUBCMD_PCMPLAYER_STOP, null);
				ret = m_proxyToRobotClient.recvResponse(sock, CMD_PCMPLAYER, SUBCMD_PCMPLAYER_START);
			
				clearSocket(sock);
			}
			
			if(ret == null) {
				System.out.println("[ERROR] Fail to stop PcmPlayer.");
			}
		} catch (IOException e) {
			System.out.printf("[EXCEPTION] stop PcmPlayer - %s\n", e.getMessage());
		}
	}
	
	/*
	public boolean openCamera(String encoding, Integer width, Integer height) {
		byte[] ret = new byte[1024];
		
		try {
			m_proxyToRobotClient.sendRequestCamera(CMD_CAMERA, SUBCMD_CAMERA_OPEN, encoding, width, height);
			ret = m_proxyToRobotClient.recvResponse(CMD_PCMPLAYER, SUBCMD_PCMPLAYER_START);
			
			if(ret == null) {
				System.out.println("[ERROR] Fail to open Camera.");
				return false;
			}
		} catch (IOException e) {
			System.out.printf("[EXCEPTION] open Camera - %s\n", e.getMessage());
		}
		
		return true;
	}
	*/
}
