// testServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "testServer.h"
#include "testServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <conio.h>

#define LISTEN_IP	"127.0.0.1"
#define LISTEN_PORT	7377


/////////////////////////////////////////////////////////////////////////////
// CtestServerDlg dialog

CtestServerDlg::CtestServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CtestServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CtestServerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_sockListen = INVALID_SOCKET;
	m_sockAccept = INVALID_SOCKET;
	m_fp = NULL;
	m_isStop = FALSE;
	m_isStopped = FALSE;
	m_hThreadServer = INVALID_HANDLE_VALUE;
	
	WSADATA wsaData;
	if(WSAStartup(MAKEWORD(2, 0), &wsaData))
	{
		AfxMessageBox("Winsock ʱȭ . α׷ .");
		exit(0);
	}

	AllocConsole();
}

CtestServerDlg::~CtestServerDlg()
{
	WSACleanup();
	FreeConsole();
}

void CtestServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CtestServerDlg)
	DDX_Control(pDX, IDC_LOG, m_log);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CtestServerDlg, CDialog)
	//{{AFX_MSG_MAP(CtestServerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RUN_SERVER, OnRunServer)
	ON_BN_CLICKED(IDC_STOP_SERVER, OnStopServer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CtestServerDlg message handlers

BOOL CtestServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CtestServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CtestServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CtestServerDlg::Log(const char *fmt, ...)
{
	va_list ap;
		
	va_start(ap, fmt);
	vsprintf(m_szLog, fmt, ap);
	strcat(m_szLog, "\r\n");
	_cprintf(m_szLog);
	va_end(ap);
	
	//strcat(m_szLog, "\r\n");
		
	//m_log.SendMessage(EM_REPLACESEL,(WPARAM) TRUE, (LPARAM) m_szLog);
}

bool CtestServerDlg::createListenSocket() {
	bool ret=false;
	int one=1;
	struct sockaddr_in sa;
	struct linger option;
	
	if((m_sockListen = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		Log("ERROR: Fail to create socket.");
		goto END;
	}
	
	if(setsockopt(m_sockListen, SOL_SOCKET, SO_REUSEADDR, (char*) &one, sizeof(one)) < 0 ) {
		Log("ERROR: Can't set socket option for socket.");
		goto END;
	}
	
	option.l_onoff = 1;
	option.l_linger = 3;
	if(setsockopt(m_sockListen, SOL_SOCKET, SO_LINGER, (char*)&option, sizeof(option)) < 0 ) {
		Log("ERROR: Can't set socket option for socket.");
		goto END;
	}
	
	memset((void*)&sa, 0x00, sizeof(sa));
	sa.sin_family = AF_INET;
	sa.sin_addr.S_un.S_addr = inet_addr(LISTEN_IP);
	sa.sin_port = htons((u_short) LISTEN_PORT);
	
	if(bind(m_sockListen, (struct sockaddr*) &sa, sizeof(sa)) < 0) {
		Log("ERROR: Can't bind TCP socket.");
		goto END;
	}
	
	if(listen(m_sockListen, 1)) {
		Log("ERROR: Can't listen TCP socket.");
		goto END;
	}

	ret = true;
	
END:
	if(ret != true) {
		closesocket(m_sockListen);
		m_sockAccept = INVALID_SOCKET;
	}

	return ret;
}

#define HEADER_LENGTH		2
#define DATA_HEADER_LENGTH	4

DWORD WINAPI funcRunServer(LPVOID pParam)
{
	CtestServerDlg *pDlg=NULL;
	static struct timeval timeout = {7, 0};
	int	nfound, addrlen;
	fd_set rmask, mask;
	struct sockaddr_in saAccept;
	char cmd, subCmd, bufData[1024*2];
	int totalRecved, nowRecv, nowTotalRecv, totalDataSize;


	pDlg = (CtestServerDlg*) pParam;


	if(pDlg->createListenSocket() == false)
		goto END;
	
	
	while(TRUE) {
		FD_ZERO(&mask);
		rmask = mask;
		
		FD_SET(pDlg->m_sockListen, &rmask);

		timeout.tv_sec = 7;
		timeout.tv_usec = 0;

		nfound = select(pDlg->m_sockListen+1, &rmask, (fd_set*) 0, (fd_set*) 0, &timeout);
		if(nfound < 0) {
			switch(nfound) {
			case EINTR : pDlg->Log("ERROR: - ȣ .");
						goto CONTINUE;
						break;
			default : pDlg->Log("ERROR: Fatal error on listen socket!");
						goto END;
			}
		}
		
		if(nfound == 0)
			goto CONTINUE;
		
		if(FD_ISSET(pDlg->m_sockListen, &rmask)) {
			addrlen = sizeof(saAccept);
			pDlg->m_sockAccept = accept(pDlg->m_sockListen, (struct sockaddr *) &saAccept, &addrlen);
			
			if(pDlg->m_sockAccept < 0) {
				pDlg->Log("ERROR: too many clients (sleep mode = 5 sec)!");
				goto CONTINUE;
			}
			
			pDlg->m_fp = fopen("c:\\recv.wav", "w");
			if(pDlg->m_fp == NULL) {
				pDlg->Log("ERROR: Fail to open file.");
				goto CONTINUE;
			}

			
			//
			nowRecv = recv(pDlg->m_sockAccept, bufData, HEADER_LENGTH, 0);
			if(nowRecv < HEADER_LENGTH) {
				pDlg->Log("ERROR: Fail to receive header.");
				goto CONTINUE;
			}
			pDlg->Log("Header: %-2.2s", bufData);

			cmd = bufData[0];
			subCmd = bufData[1];

			sprintf(bufData, "%d%d00010", cmd, subCmd);	// ϴ  
			
			
			//
			totalRecved = 0;
			do {
				nowRecv = recv(pDlg->m_sockAccept, bufData, DATA_HEADER_LENGTH, 0);
				if(nowRecv < DATA_HEADER_LENGTH) {
					pDlg->Log("ERROR: Fail to receive data header.");
					goto CONTINUE;
				}

				bufData[4] = '\0';
				totalDataSize = atoi(bufData);

				if(totalDataSize == 0) {
					pDlg->Log(" Ϸ");
					break;
				}

				nowTotalRecv = 0;
				while(nowTotalRecv < totalDataSize) {
					nowRecv = recv(pDlg->m_sockAccept, bufData+nowTotalRecv, totalDataSize-nowTotalRecv, 0);

					nowTotalRecv += nowRecv;
				}
				pDlg->Log("now Recved:%d/%d", nowTotalRecv, totalDataSize);

				totalRecved += nowTotalRecv;

				if(fwrite(bufData, 1, nowTotalRecv, pDlg->m_fp) < 0) {
					pDlg->Log("ERROR: Fail to write data to file.");
					goto CONTINUE;
				}

				fseek(pDlg->m_fp, totalRecved, SEEK_SET);
			} while(TRUE);
			pDlg->Log("End of While()");
			
			fclose(pDlg->m_fp);
			pDlg->m_fp = NULL;
			pDlg->Log("SUCCESS: write data to file.");


			//
			sprintf(bufData, "%d%d00011", cmd, subCmd);
		}

CONTINUE:
		if(pDlg->m_sockAccept != INVALID_SOCKET) {
			send(pDlg->m_sockAccept, bufData, strlen(bufData), 0);

			closesocket(pDlg->m_sockAccept);
			pDlg->m_sockAccept = INVALID_SOCKET;
		}
		
		if(pDlg->m_fp != NULL) {
			fclose(pDlg->m_fp);
			pDlg->m_fp = NULL;
		}

		Sleep(100);

		if(pDlg->m_isStop == TRUE)
			break;
	}
	
END:
	if(pDlg->m_sockListen != INVALID_SOCKET) {
		closesocket(pDlg->m_sockListen);
		pDlg->m_sockListen = INVALID_SOCKET;
	}

	if(pDlg->m_sockAccept != INVALID_SOCKET) {
		closesocket(pDlg->m_sockAccept);
		pDlg->m_sockAccept = INVALID_SOCKET;
	}
	
	if(pDlg->m_fp != NULL) {
		fclose(pDlg->m_fp);
		pDlg->m_fp = NULL;
	}

	pDlg->m_isStopped = TRUE;
}

void CtestServerDlg::OnRunServer() 
{
	m_isStop = FALSE;
	m_isStopped = FALSE;

	m_hThreadServer = CreateThread(NULL, 0, funcRunServer, this, NULL, NULL);

	if(m_hThreadServer == INVALID_HANDLE_VALUE) {
		Log("ERROR: Fail to create server socket thread.");
	}
	else {
		CloseHandle(m_hThreadServer);

		GetDlgItem(IDC_RUN_SERVER)->EnableWindow(FALSE);
		GetDlgItem(IDC_STOP_SERVER)->EnableWindow(TRUE);
	}
}

void CtestServerDlg::OnStopServer() 
{
	if(m_hThreadServer != INVALID_HANDLE_VALUE) {
		m_isStop = TRUE;

		while(m_isStopped == FALSE)
			Sleep(1000);

		CloseHandle(m_hThreadServer);
		m_hThreadServer = INVALID_HANDLE_VALUE;
	}
	
	GetDlgItem(IDC_RUN_SERVER)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP_SERVER)->EnableWindow(FALSE);
}

void CtestServerDlg::OnOK() 
{
	OnStopServer();
	
	CDialog::OnOK();
}
